/* -----------------------FTPM Version 1.0------------------------- *
 *            written by Matt Jukins (mpj1@kepler.unh.edu)          *
 *                              7/94	                            *
 *								    *
 *	Any questions/comments/suggestions should be sent to        *
 *	me at the above address.  Feel free to distribute 	    *
 *	this program freely, under the condition that this          *
 *      header stay intact, and all the files included with	    *
 *	this package *stay* with this package.  :) 		    *
 *								    *
 *  	Feel free to change whatever you like, but I ask that	    *
 *	you please send me any new versions that you may write      *
 *								    *
 *				Thanks,				    *
 *			 	    Matt Jukins			    *
 * ---------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include "conf.h"

void help(void);
void listsites(void);
void addsite(char **blah);
void site_num(char **blah);
void rm_site(char **blah);

main(int argc, char **argv)
  {
  char sitename[25];
  char newsite[80];
  char ftp[30];

  FILE *fout;

  fout=fopen(PROG,"w");

  if((argc<2)||(argc>3))
    {       
    printf("usage: ftpm <sitename>\t\tto ftp to <sitename>\n");
    printf("       ftpm -a <sitename>\tto add <sitename> to FTPM address");
    printf(" book\n");
    printf("       ftpm -r <number>\t\tto remove <number> from FTPM address");
    printf(" book\n");
    printf("       ftpm -n <number>\t\tto ftp to <number> site in\n");
    printf("\t\t\t\tyour FTPM address book\n");
    printf("       ftpm -l\t\t\tto look at your FTPM address book\n");
    printf("       ftpm -h\t\t\tto get a quick help page\n");
    printf("       ftpm -v\t\t\tto see the version number\n");
    exit(1);
    }

  if(!strcasecmp(argv[1],"-v"))
    {
    printf("Version %s\n",VERSION);
    exit(0);  
    }

  if(!strcasecmp(argv[1],"-h"))
    {
    help();
    exit(0);
    }

  if(!strcasecmp(argv[1],"-l"))
    {
    listsites();
    exit(0);
    }

  if((!strcasecmp(argv[1],"-n"))&&(argc==2))
    {
    printf("usage: ftpm -n <number>\n");
    exit(1);
    }

  if(!strcasecmp(argv[1],"-n"))
    {
    if(!((*argv[2]>=060)&&(*argv[2]<=071)))
      {
      printf("Argument must be a number.\n");
      exit(1);
      }
   
    site_num(argv); 
    exit(0);
    }  

  if((!strcasecmp(argv[1],"-r"))&&(argc==2))
    {
    printf("usage: ftpm -r <number>\n");
    exit(1);
    }

  if(!strcasecmp(argv[1],"-r"))
    {
    if(!((*argv[2]>=060)&&(*argv[2]<=071)))
      {
      printf("Argument must be a number.\n");
      exit(1);
      }
   
    rm_site(argv); 
    exit(0);
    }  
  
  if((!strcasecmp(argv[1],"-a"))&&(argc==2))
    {
    printf("usage: ftpm -a <sitename>\n");
    exit(1);
    }

  if(!strcasecmp(argv[1],"-a"))
    {
    addsite(argv);
    exit(0);
    }

  sprintf(newsite,"machine %s login anonymous password %s\n",argv[1],USER); 
  fprintf(fout,"%s",newsite);
  fclose(fout);
  sprintf(ftp,"ftp %s",argv[1]);
  system(ftp);
  exit(0);
  }
  
void help(void)
  {
  printf("                         FTPM v1.0 Helps");
  printf("creen \n");
  printf(" + -------------------------------------");
  printf("----------------------------------- +\n");
  printf("\n\t This program is intended for use with ANONYMOUS FTP sites\n");
  printf("\n");
  printf(" \t* ftpm <sitename>   \twill call on the ");
  printf("ftp program to open  \n");
  printf("\t\t\t\tup the given <sitename>, except you ");
  printf("\t\n");
  printf("\t\t\t\twon't have to type in your username\n");
  printf("\t\t\t\tor password.   \n");
  printf(" \t* ftpm -n <number>  \twill open up the FTP site that\n");
  printf("\t\t\t\tcorresponds with <number> in your FTPM\n");
  printf("\t\t\t\taddress book\n");
  printf(" \t* ftpm -r <number>  \twill remove the FTP site that\n");
  printf("\t\t\t\tcorresponds with <number> in your FTPM\n");
  printf("\t\t\t\taddress book\n");
  printf(" \t* ftpm -h\t\twill give you this helpscre");
  printf("en\n");
  printf("\t* ftpm -v\t\twill simply print the versio");
  printf("n number\n");
  printf(" \t* ftpm -a <sitename>\twill let you add <sitename>\n");
  printf("\t\t\t\tto your FTPM address book\n");
  printf("\t* ftpm -l\t\twill show you your FTPM address book\n");
  }

void listsites(void)
  {
  int num; 
  int num2=1;
  char site[35];

  FILE *fin;
 
  fin=fopen(SITES,"r");
 
  if(!fin)
    {
    printf("You currently have zero sites stored in your address book.\n");
    exit(1);
    }

  printf("\t[4mNumber:[0m\t\t[4mSite:[0m\n");

  while(fscanf(fin,"%d",&num)!=EOF)
     {
     fscanf(fin,"%s",site);
     printf("\t   %d\t\t%s\n",num2++,site);
     } 
  } 

void addsite(char **argv)
  {
  int temp; 
  char nothing[30];

  FILE *fread,*fadd;

  fadd=fopen(SITES,"a");
  fread=fopen(SITES,"r");
   
  while(fscanf(fread,"%d%s",&temp,nothing)==2)
     ;

  fprintf(fadd,"%d\t%s\n",temp+1,argv[2]);
  fclose(fadd);
  fclose(fread);
  }

void site_num(char **argv)
  {
  char number[4];
  char blah[30];
  char site2[30];
  char ftp2[36];
  char newsite2[100];

  FILE *fnum,*fout;
  
  fnum=fopen(SITES,"r");
  fout=fopen(PROG,"w");

  if(!fnum)
    {
    printf("Cannot open file .sites for reading\n"); 
    exit(1);
    }

  while(fscanf(fnum,"%s",number)!=EOF)
    {
    if(!strcasecmp(number,argv[2]))
      {
      fscanf(fnum,"%s",site2);
      sprintf(newsite2,"machine %s login anonymous password %s\n",site2,USER); 
      fprintf(fout,"%s\n",newsite2);
      fclose(fnum);
      fclose(fout);
      sprintf(ftp2,"ftp %s",site2);
      system(ftp2);
      exit(0);
      }
    else
      {
      fscanf(fnum,"%s",blah);
      } 
    }
    printf("Site number %s not found in address book.\n",argv[2]);
  }

void rm_site(char **argv)
  {
  int count=0;
  int count2=0;
  int badcount;
  char sites[80][60];
  FILE *fp;

  fp=fopen(SITES,"r");

  while(fgets(sites[count++],81,fp))
    {
    if(count==atoi(argv[2]))
      {
      badcount=(count-1);
      continue;
      }
    }
  fclose(fp);
  count--;
  if(count<atoi(argv[2]))
    {
    printf("Site number %s not found in address book\n",argv[2]);
    exit(1);  
    }

  fp=fopen(SITES,"w");
  while(count!=0)
    {
    if(count2==badcount)
      {
      count2++;
      continue; 
      }
    fputs(sites[count2++],fp);
    count--;
    }
  }
 
